<?php
	@ini_set('zlib.output_compression',0);
	@ini_set('implicit_flush',1);
	@ob_end_clean();
	set_time_limit(0);

	require __DIR__ . '/vendor/autoload.php';
	use OTPHP\HOTP;
	session_start();
	set_time_limit(1800); //to scriptaki diarkei max 30 lepta
	$time_start = microtime(true);
	$xsize = $_GET['xsize'];
	$ysize = $_GET['ysize'];
	$posX = $_GET['posX'];
	$posY = $_GET['posY'];
	$page =$_GET['page'];
	$name = $_GET['name'];  
	$signText = $_GET['signText']; 
	$sendpassValue = $_GET['sendpass'];
	//echo $sendpassValue;
	$selectedFields = $_GET['selectedFields'];
	$otpMethod = $_GET['otpMethod']; 
	
	$xTrans = ($xsize * 0.03937007874)*72;
	$yTrans = ($ysize * 0.03937007874)*72;
	$ulx = intval($posX * $xTrans - 72);   // σε dots  με 72dpi
	$uly = intval($posY * $yTrans - 36);	  // σε dots  με 72dpi	
	//echo $name;
	$error = 0;
	$otpParameter = "";
	if ($otpMethod == "mail"){
		$imap = @imap_open("{mail.sch.gr}",$_SESSION['userSch'],$_SESSION['userPass']);
		$otpParameter = $imap;
	}
	else{
		$file = '../../counter.txt';
		$otpParameter = file_get_contents($file);
	}
	sign_all_files('files',$ulx,$uly,$page,iconv("UTF-8", "CP1253",'files'),$signText,$error,$otpMethod,$otpParameter);
	$time_end = microtime(true);
	$time = $time_end - $time_start;
	echo "<span style='color:purple;'>Συνολικός χρόνος εκτέλεσης ".$time."sec</span>";
	//echo $signText;
	if ($otpMethod == "mail"){
		imap_close($imap );
	}
	//check if all files exits
	echo "Έλεγχος ορθότητας δημιουργίας αρχείων ...";
	check_all_files('files');
	
	
	
	function sign_all_files($dir,$ulx,$uly,$page,$iconvDir,$signText,$error,$otpMethod,$otpParameter)
	{
		$signTextforCommand = iconv(mb_detect_encoding($signText), "CP1253",$signText);	
		$root = scandir(iconv("UTF-8", "CP1253",$dir));
		$newdir= "output\\".$dir;
		@mkdir($newdir);
		//echo $newdir;
		@flush();
		@ob_flush();

		$otp = -100;
		//$time_start = microtime(true);
		echo "Λήψη OTP ...";
		$time_start = microtime(true);
		@flush();
		@ob_flush();	
		include 'getLastOTP.php';
		$time_end = microtime(true);
		$time = $time_end - $time_start;
		echo $otp.". Χρόνος λήψης OTP : ".$time."sec.";
		@flush();
		@ob_flush();
		
		if ($getOtpResult == 0 || $getOtpResult == 1){
			//$time_start = microtime(true);
			if ($signText ==""){
				//dmaked_sign_multiple
				$command = 'java -jar "'.$_SESSION['websiteFolder'].'\signAll\dmaked_sign_multiple2.jar" '.$_SESSION['userMindigital'].' '.$_SESSION['passMindigital'].' '.$otp.' "@'.$iconvDir.'" 1 '.$page.' '.$ulx.' '.$uly;
			}
			else{
				//$command = 'java -jar "'.$_SESSION['websiteFolder'].'\signAll\mindigital_dmaked_pub.jar" '.$_SESSION['userMindigital'].' '.$_SESSION['passMindigital'].' '.$otp.' "'.$iconvDir.'\\'.iconv(mb_detect_encoding($value), "CP1253",$value).'" 1 '.$page.' '.$ulx.' '.$uly.' "'.$signTextforCommand.'"';
				$command = 'java -jar "'.$_SESSION['websiteFolder'].'\signAll\dmaked_sign_multiple2.jar" '.$_SESSION['userMindigital'].' '.$_SESSION['passMindigital'].' '.$otp.' "@'.$iconvDir.'" 1 '.$page.' '.$ulx.' '.$uly.' "'.$signTextforCommand.'"';

			}
			//$time_end = microtime(true);
			//$time = $time_end - $time_start;
			//echo " Χρόνος εκτέλεσης : ".$time."sec ";
			//echo $command;
			echo "Υπογραφή ".count(glob($dir ."/*"))." αρχείων του φακέλου ".$dir.". Παρακαλώ περιμένετε ...";
			@flush();
			@ob_flush();
			//exit();
			exec($command,$output3);
			//var_dump($output3);
			@flush();
			@ob_flush();
			//if (true){
				//rename($iconvDir.'\\'.$file_parts['filename']."_signed.".$file_parts['extension'],"output\\".$iconvDir.'\\'.$file_parts['filename']."_signed.".$file_parts['extension']);
				//echo "<span style='color:green;'>Ο φάκελος ".$iconvDir.'\\'." έχει υπογραφεί με επιτυχία (".$getOtpResultDesc.")</span><br>";
				//$error = 0;
			//}
			@flush();
			@ob_flush();
		}
		else{
			echo $getOtpResultDesc;
			if ($otpMethod == "mail"){
				imap_close($imap );
			}
			exit(2);
		}
		
		foreach($root as $value)
		{
			if($value === '.' || $value === '..') {continue;}
			if(is_file("$dir/$value")) {continue;}			
			//echo "<BR>".$dir."\\".$value."-- nea klisi sinartisis";
			$newiconvDir = $iconvDir."\\".iconv("UTF-8", "CP1253",$value);
			sign_all_files("$dir\\$value",$ulx,$uly,$page,$newiconvDir,$signText,$error,$otpMethod,$otpParameter);
		}
	}
	
	function mime_header_decode($header) {
        $source = imap_mime_header_decode($header);
        //result[] = new result;
        //$result[0]->text='';
        //$result[0]->charset='ISO-8859-1';
		//$result[0]->charset=detect_charset($source[$j]->text);
		$str = "";
        for ($j = 0; $j < count($source); $j++ ) {
           $element_charset =  ($source[$j]->charset == 'default') ? 'ISO-8859-1' : $source[$j]->charset;
			 if ($element_charset == '' || $element_charset == null) {
				$element_charset = 'ISO-8859-1';

			}
			if (($element_charset =="UTF-8")||($element_charset =="utf-8")){
				//$element_converted = ConvertToUTF8($source[$j]->text);
				$element_converted = $source[$j]->text;					
            }
			else{
				$element_converted = iconv($element_charset, 'UTF-8', $source[$j]->text);
				if (!$element_converted){
					//return "error in mail ".$source[$j]->text;
					//continue;
				}
			}
			$result[$j] = new stdClass();
            $result[$j]->text = $element_converted;
            $result[$j]->charset = 'UTF-8';
			$str .= $result[$j]->text;
        }
        return $str;

    }
	
	function getLastOTP($imap, $nextuid){
		$OTP = -100;
		$MC = imap_check($imap);
		$lastMessage = $MC->Nmsgs;
		$firstMessage = $MC->Nmsgs-5;
		
		//$info =array_reverse(imap_fetch_overview($imap,"{$nextuid}:*",FT_UID));
		$info =array_reverse(imap_fetch_overview($imap,"{$firstMessage}:{$lastMessage}"));
		//echo "αριθμός μηνυμάτων για αναζήτηση :".sizeof($info);
		$i=0;
		$lastUidSelected = 0;
		foreach ($info as $msg) {
			if ($msg->uid < $nextuid){
				//echo " μικρότερο uid ".$msg->uid."</br>";
				continue;	
			}
			$i++;
			//echo $i;
			if(mime_header_decode($msg->subject) == "Κωδικός Ψηφιακής Υπογραφής μιας χρήσης"){	
				if ($msg->uid > $lastUidSelected){
					$lastUidChecked = $msg->uid;
					$text = imap_base64(imap_body($imap, $msg->msgno));
					$text = explode("<br>",$text);
					$text = $text[0];
					$text = explode(" ",$text);
					$text = end($text);
					//echo "getting OTP :".strip_tags($text);
					$OTP=strip_tags($text);
				}
			}
		}
		return $OTP;
	}
	
	function getLastOTPDevice(){
		$OTP = -100;
		$myfile = fopen("../../code.txt" , "r");
		$sec = fgets($myfile);
		fclose($myfile);
		//$sec_dec = openssl_decrypt($sec, 'aes-128-cbc', "1234567812345678", 0, "1234567812345678");
		$otp = HOTP::create($sec,8,'sha1',6);
		$otp->setIssuer('KSHDE SIGNATURE OTP');
		$file = '../../counter.txt';
		$counter = file_get_contents('../../counter.txt');
		$OTP = $otp->generate($counter);
		$counter++;
		file_put_contents($file, $counter);
		return $OTP;
	}
	
	function check_all_files($dir)
	{
		$root = scandir($dir);
		foreach($root as $value)
		{
			if($value === '.' || $value === '..') {continue;}
			if(is_file("$dir/$value")) {
				$file_parts = pathinfo("$dir/$value");

				switch($file_parts['extension'])
				{
					case "pdf":
					if (!file_exists("output/"."$dir/".$file_parts['filename']."_signed.pdf")){
						echo "<div style='color:red'>Το αρχείο $dir/$value δεν έχει δημιουργηθεί</div>"; 
					}
					break;
				}
				continue;
			}
			check_all_files("$dir/$value");
		}
		return ;
	}
	
?>
